#ifndef BISON_CF_PARSE_TAB_H
# define BISON_CF_PARSE_TAB_H

#ifndef YYSTYPE
typedef union {
  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	END	257
# define	CLI_MARKER	258
# define	INVALID_TOKEN	259
# define	GEQ	260
# define	LEQ	261
# define	NEQ	262
# define	AND	263
# define	OR	264
# define	NUM	265
# define	ENUM	266
# define	RTRID	267
# define	IPA	268
# define	SYM	269
# define	TEXT	270
# define	PREFIX_DUMMY	271
# define	DEFINE	272
# define	ON	273
# define	OFF	274
# define	YES	275
# define	NO	276
# define	LOG	277
# define	SYSLOG	278
# define	ALL	279
# define	DEBUG	280
# define	TRACE	281
# define	INFO	282
# define	REMOTE	283
# define	WARNING	284
# define	ERROR	285
# define	AUTH	286
# define	FATAL	287
# define	BUG	288
# define	STDERR	289
# define	CONFIGURE	290
# define	DOWN	291
# define	KERNEL	292
# define	PERSIST	293
# define	SCAN	294
# define	TIME	295
# define	LEARN	296
# define	DEVICE	297
# define	ASYNC	298
# define	TABLE	299
# define	ROUTER	300
# define	ID	301
# define	PROTOCOL	302
# define	PREFERENCE	303
# define	DISABLED	304
# define	DIRECT	305
# define	INTERFACE	306
# define	IMPORT	307
# define	EXPORT	308
# define	FILTER	309
# define	NONE	310
# define	STATES	311
# define	ROUTES	312
# define	FILTERS	313
# define	PASSWORD	314
# define	FROM	315
# define	PASSIVE	316
# define	TO	317
# define	EVENTS	318
# define	PACKETS	319
# define	PROTOCOLS	320
# define	INTERFACES	321
# define	PRIMARY	322
# define	STATS	323
# define	COUNT	324
# define	FOR	325
# define	COMMANDS	326
# define	SHOW	327
# define	STATUS	328
# define	SUMMARY	329
# define	ROUTE	330
# define	SYMBOLS	331
# define	DUMP	332
# define	RESOURCES	333
# define	SOCKETS	334
# define	NEIGHBORS	335
# define	ATTRIBUTES	336
# define	ECHO	337
# define	DISABLE	338
# define	ENABLE	339
# define	RESTART	340
# define	FUNCTION	341
# define	PRINT	342
# define	PRINTN	343
# define	UNSET	344
# define	RETURN	345
# define	ACCEPT	346
# define	REJECT	347
# define	QUITBIRD	348
# define	INT	349
# define	BOOL	350
# define	IP	351
# define	PREFIX	352
# define	PAIR	353
# define	SET	354
# define	STRING	355
# define	BGPMASK	356
# define	BGPPATH	357
# define	CLIST	358
# define	IF	359
# define	THEN	360
# define	ELSE	361
# define	CASE	362
# define	TRUE	363
# define	FALSE	364
# define	GW	365
# define	NET	366
# define	MASK	367
# define	SOURCE	368
# define	SCOPE	369
# define	CAST	370
# define	DEST	371
# define	LEN	372
# define	DEFINED	373
# define	ADD	374
# define	DELETE	375
# define	CONTAINS	376
# define	RESET	377
# define	PREPEND	378
# define	MATCH	379
# define	EMPTY	380
# define	WHERE	381
# define	EVAL	382
# define	BGP	383
# define	LOCAL	384
# define	NEIGHBOR	385
# define	AS	386
# define	HOLD	387
# define	CONNECT	388
# define	RETRY	389
# define	KEEPALIVE	390
# define	MULTIHOP	391
# define	STARTUP	392
# define	VIA	393
# define	NEXT	394
# define	HOP	395
# define	SELF	396
# define	DEFAULT	397
# define	PATH	398
# define	METRIC	399
# define	START	400
# define	DELAY	401
# define	FORGET	402
# define	WAIT	403
# define	AFTER	404
# define	BGP_PATH	405
# define	BGP_LOCAL_PREF	406
# define	BGP_MED	407
# define	BGP_ORIGIN	408
# define	BGP_NEXT_HOP	409
# define	BGP_ATOMIC_AGGR	410
# define	BGP_AGGREGATOR	411
# define	BGP_COMMUNITY	412
# define	ADDRESS	413
# define	OSPF	414
# define	AREA	415
# define	OSPF_METRIC1	416
# define	OSPF_METRIC2	417
# define	OSPF_TAG	418
# define	RFC1583COMPAT	419
# define	STUB	420
# define	TICK	421
# define	COST	422
# define	RETRANSMIT	423
# define	HELLO	424
# define	TRANSMIT	425
# define	PRIORITY	426
# define	DEAD	427
# define	NONBROADCAST	428
# define	POINTOPOINT	429
# define	TYPE	430
# define	SIMPLE	431
# define	AUTHENTICATION	432
# define	STRICT	433
# define	ELIGIBLE	434
# define	POLL	435
# define	NETWORKS	436
# define	HIDDEN	437
# define	PIPE	438
# define	PEER	439
# define	RIP	440
# define	INFINITY	441
# define	PORT	442
# define	PERIOD	443
# define	GARBAGE	444
# define	TIMEOUT	445
# define	PASSWORDS	446
# define	MODE	447
# define	BROADCAST	448
# define	MULTICAST	449
# define	QUIET	450
# define	NOLISTEN	451
# define	VERSION1	452
# define	PLAINTEXT	453
# define	MD5	454
# define	HONOR	455
# define	NEVER	456
# define	ALWAYS	457
# define	RIP_METRIC	458
# define	RIP_TAG	459
# define	STATIC	460
# define	DROP	461
# define	PROHIBIT	462


extern YYSTYPE cf_lval;

#endif /* not BISON_CF_PARSE_TAB_H */
