#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <wait.h>

#include <bcmdevs.h>
#include <bcmnvram.h>
#include <netconf.h>
#include <shutils.h>
#include <utils.h>
#include <cy_conf.h>
#include <code_pattern.h>
#include <rc.h>

static char* get_wshaper_dev(void)
{
  if(nvram_match("wshaper_dev", "WAN") && nvram_match("wan_proto", "pppoe"))
    return "ppp0";
  else if(nvram_match("wshaper_dev", "WAN")  && (strtoul(nvram_safe_get("boardflags"), NULL, 0) & BFL_ENETVLAN))
    return "vlan1";
  else if(nvram_match("wshaper_dev", "WAN"))
    return "eth1";
  else
    return "br0";
}

int start_wshaper(void)
{
  int   ret = 0;
  char* dev_val;
  char* dl_val;
  char* ul_val;
  char  ulcalc1_val[32] = "";
  char  ulcalc2_val[32] = "";
  char* nopriohostsrc_val;
  char* nopriohostdst_val;
  char* noprioportsrc_val;
  char* noprioportdst_val;
  int   ulcalc1 = 0;
  int   ulcalc2 = 0;

  stop_wshaper();

  if (!nvram_invmatch("wshaper_enable", "0"))
    return 0;

  dev_val = get_wshaper_dev();

  if((dl_val = nvram_safe_get("wshaper_downlink")) == NULL &&
     atoi(dl_val) > 0)
    return 0;

  if((ul_val = nvram_safe_get("wshaper_uplink")) == NULL &&
    atoi(ul_val) > 0)
    return 0;

  nopriohostsrc_val = nvram_safe_get("wshaper_nopriohostsrc");
  nopriohostdst_val = nvram_safe_get("wshaper_nopriohostdst");
  noprioportsrc_val = nvram_safe_get("wshaper_noprioportsrc");
  noprioportdst_val = nvram_safe_get("wshaper_noprioportdst");

  ulcalc1 = 9*atoi(ul_val)/10;
  ulcalc2 = 8*atoi(ul_val)/10;

  sprintf(ulcalc1_val, "%d", ulcalc1);
  sprintf(ulcalc2_val, "%d", ulcalc2);

  ret = eval("/usr/sbin/wshaper", dl_val, ul_val, dev_val, ulcalc1_val, ulcalc2_val, nopriohostsrc_val, nopriohostdst_val, noprioportsrc_val, noprioportdst_val);

  return ret;
}

int stop_wshaper(void)
{
  int ret = 0;
  char*  dev_val;

//  dev_val = get_wshaper_dev();

//  ret = eval("/usr/sbin/wshaper","stop", "XX", dev_val);

    ret = eval("/usr/sbin/wshaper","stop", "XX", "br0");
    if(strtoul(nvram_safe_get("boardflags"), NULL, 0) & BFL_ENETVLAN)
      ret = eval("/usr/sbin/wshaper","stop", "XX", "vlan1");
    else
      ret = eval("/usr/sbin/wshaper","stop", "XX", "eth1");

      stop_firewall();
      start_firewall();
      
  return ret;
}
